<?php
$HTML_TEMPLATE = <<<eot
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>File Upload (PHP)</title>
</head><body><h1>File Upload (PHP)</h1>
<form action="?action=upload" method="post" enctype="multipart/form-data">
<input type="hidden" name="action" value="upload"/>
File name: <input name="file" type="file"/><br/>
<input name="submit" type="submit"/>
</form>
</body>
</html>
eot;

$UPLOAD_TEMPLATE = <<<eot
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>Gallery View (Ruby)</title>
</head><body><h1>Gallery View (Ruby)</h1>
eot;

$UPLOAD_DIR = "./tmp";
$start = microtime_float();

function error($text) {
	echo "<html><body><h1>".$text."</h1></body></html>";
	exit();
}

function processFile($key) {
	global $UPLOAD_DIR;
	$filepath = $UPLOAD_DIR."/" . basename( $_FILES[$key]['name']); 
	move_uploaded_file($_FILES[$key]['tmp_name'], $filepath);
	return $filepath;
}

function unzip($filepath, $dir) {
	$zip = new ZipArchive;
	$zip->open($filepath);
	for ($i=0; $i<$zip->numFiles;$i++) {
		$item = $zip->statIndex($i);
		preg_match('/([^\/]*)$/',$item['name'],$regs);
		$filename = $regs[1];
		if ($filename=="") continue;
		if (preg_match('/^\./', $filename)) continue;
		$fp = $zip->getStream($item['name']);
		$contents = '';
		while (!feof($fp)) {
        $contents .= fread($fp, 2);
    }
    fclose($fp);
		file_put_contents($dir."/". $filename,$contents);
	}
	$zip->close();
}

function createThumbnails($dir) {
	$handle = opendir($dir);
	while (false !== ($file = readdir($handle))) {
		if ($file == ".") continue;
		if ($file == "..") continue;
		if (!preg_match('/\.jpg$/', $file)) continue;
		if (preg_match('/_T\.jpg$/', $file)) continue;
		if (preg_match('/^\./', $file)) continue;
		$inputfile = $dir."/".$file;
		preg_match('/(.*)\.jpg$/',$file,$regs);
		$outputfile = $dir."/".$regs[1]."_T.jpg";
		$cmd = "/usr/local/bin/convert -resize 100x100 $inputfile $outputfile";
		exec($cmd);
	}
}

function generateWebsite($dir) {
	global $UPLOAD_TEMPLATE,$timeUpload,$timeUnzip,$timeThumbnails;
 	$html = $UPLOAD_TEMPLATE;
	$handle = opendir($dir);
	while (false !== ($file = readdir($handle))) {
		if ($file == ".") continue;
		if ($file == "..") continue;
		if (!preg_match('/\.jpg$/', $file)) continue;
		if (preg_match('/_T\.jpg$/', $file)) continue;
		if (preg_match('/^\./', $file)) continue;
		$inputfile = $dir."/".$file;
		preg_match('/(.*)\.jpg$/',$file,$regs);
		$outputfile = $dir."/".$regs[1]."_T.jpg";
		$html .= '<div class="image"><a href="';
		$html .= $inputfile;
		$html .= '"><img src="';
		$html .= $outputfile;
		$html .= '"/></a></div>';
	}
 	$html .= "Store file: $timeUpload seconds<br/>";
 	$html .= "Unzip file: ".($timeUnzip-$timeUpload)." seconds<br/>";
	$html .= "Create thumbnails: ".($timeThumbnails-$timeUnzip)." seconds<br/>";
 	$html .= "Overall: $timeThumbnails seconds<br/>";
 	$html .= "</body></html>";
	return $html;
}

function microtime_float() {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

if ($argc>1) {
	# wir haben ein command line argument!
	echo "Command line";
	$filepath = $argv[1];
	$timeUpload = microtime_float()-$start;
	unzip(filepath, UPLOAD_DIR);
	$timeUnzip = microtime_float()-$start;
	createThumbnails(UPLOAD_DIR);
	$timeThumbnails = microtime_float()-$start;
	$html = generateWebsite(UPLOAD_DIR);
#	File.open("gallery.html", 'w') {|f| f.write(html) }
	exit();
} else {
	if ($_GET['action'] == "upload") {
		$filepath = processFile('file');
		$timeUpload = microtime_float()-$start;
		unzip($filepath, $UPLOAD_DIR);
		$timeUnzip = microtime_float()-$start;
		createThumbnails($UPLOAD_DIR);
		$timeThumbnails = microtime_float()-$start;
		echo generateWebsite($UPLOAD_DIR);
		exit();
	}
	echo $HTML_TEMPLATE;
}
?>